import { GlobalStoreConfig } from './GlobalStore.types';
import { ActionCollectionConfig, GlobalStoreAbstract, SetStateCallback, StateChangesParam, StateConfigCallbackParam, StateSetter } from 'react-native-global-state-hooks';
export declare class GlobalStore<TState, TMetadata = null, TStateSetter extends ActionCollectionConfig<TState, TMetadata> | StateSetter<TState> = StateSetter<TState>> extends GlobalStoreAbstract<TState, TMetadata, NonNullable<TStateSetter>> {
    protected config: GlobalStoreConfig<TState, TMetadata, TStateSetter>;
    constructor(state: TState, config?: GlobalStoreConfig<TState, TMetadata, TStateSetter>, actionsConfig?: TStateSetter | null);
    protected onInitialize: ({ setState, getState, }: StateConfigCallbackParam<TState, TMetadata>) => void;
    protected onChange: ({ getState, }: StateChangesParam<TState, TMetadata, NonNullable<TStateSetter>>) => void;
    /**
     * set the state and update all the subscribers
     * @param {StateSetter<TState>} setter - The setter function or the value to set
     * @param {SetStateCallback} invokerSetState - The setState function of the component that invoked the state change (optional) (default: null) this is used to updated first the component that invoked the state change
     * */
    protected setState: ({ invokerSetState, state, forceUpdate, }: {
        state: TState;
        invokerSetState?: SetStateCallback;
        forceUpdate: boolean;
    }) => void;
}
